
CBOI
C
C !TITLE: TANGENTLINEAR CODE
C !AUTHORS: mitgcm developers ( support@mitgcm.org )
C !AFFILIATION: Massachussetts Institute of Technology
C !DATE:
C !INTRODUCTION: tangentlinear code collection
c \bv
c Top level routine for tangentlinear code generation is the_main_loop.
c Tangentlinear code is generated via the makefile in adjoint/
c 0. make restore:
c    Re-instate header or tangentlinear_model.F from template
c 1. make:
c    All .f files are concatenated into one file
c    tamc_code.f
c 2. make ftltaf:
c    This makefiles contains a list of all routines which must be
c    differentiated (i.e. analyzed by TAMC/TAF) and those which
c    must not be differentiated. For the latter, files containing
c    flow directives are given.
c    The code generated by TAMC/TAF is written to
c    tamc_code_ftl.f
c 3. make ftlchange:
c    To maintain the multi-threading index mythid,
c    the tangentlinear code must be post-processed.
c    All parameter lists of active I/O routines 
c    (active read/write open/close) are augmented by mythid.
c    The resulting code is copied to
c    tamc_code_sed_ftl.f
c    and concatenated to tangentlinear_model.F
c
c     Documentation:
c     ==============
c     For a documentation of TAMC see:
c     http://puddle.mit.edu/~ralf/tamc/tamc.html
c     For more info on TAF see:
c     http://www.fastopt.de
C \ev
CBOI

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: tangentlinear_model
C     !INTERFACE:
      subroutine tangentlinear_model(mythid )

C     !DESCRIPTION: \bv
c     ==================================================================
c     SUBROUTINE tangentlinear_model
c     ==================================================================
c     o This is just a place holder for the TAMC generated tangentlinear
c       code of the MITgcmuv and related routines. Below you find a short
c       description of some topics pertaining to the tangentlinear model.
c       This routine will be overwritten as soon as TAMC will have
c       generated the tangentlinear model. If you want to keep it copy it
c       to another place.
c     started: Christian Eckert eckert@mit.edu 21-Jul-1999
c     ==================================================================
c     SUBROUTINE tangentlinear_model
c     ==================================================================
C     \ev

C     !USES:
      implicit none

c     == routine arguments ==

      integer mythid

c     == end of interface ==
CEOP

      return
      end
